# -*-Shell-script-*-
# PS4='+ $(date "+%s.%N")\011 '
# set -x
#########################################################################
# This program is free software: you can redistribute it and/or modify #
# it under the terms of the version 3 of the GNU General Public License #
# as published by the Free Software Foundation. #
# #
# This program is distributed in the hope that it will be useful, but #
# WITHOUT ANY WARRANTY; without even the implied warranty of #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU #
# General Public License for more details. #
# #
# You should have received a copy of the GNU General Public License #
# along with this program. If not, see . #
# #
# Written by and Copyright (C) Francois Fleuret #
# Contact for comments & bug reports #
#########################################################################
# The site-specific and confidential settings are in another file
PRIVATE_BASHRC="${HOME}/private/bashrc.perso"
# If the MANPATH is not set, set it
[[ "${MANPATH}" ]] || MANPATH=$(manpath)
export EDITOR='emacs -nw'
export GIT_EDITOR=${EDITOR}
# If the private bashrc exists, execute it
[[ -f "${PRIVATE_BASHRC}" ]] && source "${PRIVATE_BASHRC}"
# !!! THIS HAS TO BE HERE EVEN IN THE NON-INTERACTIVE PART OR YOU WILL
# LOSE YOU PREVIOUS HISTORY !!!
export HISTFILESIZE=20000
export HISTSIZE=${HISTFILESIZE}
export HISTIGNORE="${HISTIGNORE}:&:[ ]*"
# I want to save the command time, but I do not want to see it in
# history
export HISTTIMEFORMAT=""
shopt -s histappend
shopt -s autocd
# I realized that most of my settings are meaningful only in
# interactive mode. This should maybe be done more properly through
# using different .bash_profile and .bash_login
######################################################################
# added by Miniconda3 installer
export PATH="${HOME}/conda/bin:$PATH"
[ ${TERM} == "dumb" ] || [[ ! -t 0 ]] && return
# Remove the annoying beeps in console
# setterm -blength 0
# || setterm --blength 0 # Seriously?
######################################################################
## The interactive part
export VT_RESET=$'\e[0m'
export VT_BOLD=$'\e[1m'
export VT_UNDERLINE=$'\e[4m'
export VT_BLINK=$'\e[5m'
export VT_SET_TITLE=$'\e]0;'
export VT_END_TITLE=$'\007'
export VT_BLACK_FG=$'\e[30m'
export VT_RED_FG=$'\e[31m'
export VT_GREEN_FG=$'\e[32m'
export VT_YELLOW_FG=$'\e[33m'
export VT_BLUE_FG=$'\e[34m'
export VT_MAGENTA_FG=$'\e[35m'
export VT_CYAN_FG=$'\e[36m'
export VT_WHITE_FG=$'\e[37m'
export VT_BLACK_BG=$'\e[40m'
export VT_RED_BG=$'\e[41m'
export VT_GREEN_BG=$'\e[42m'
export VT_YELLOW_BG=$'\e[43m'
export VT_BLUE_BG=$'\e[44m'
export VT_MAGENTA_BG=$'\e[45m'
export VT_CYAN_BG=$'\e[46m'
export VT_WHITE_BG=$'\e[47m'
# Colorize man pages!
export LESS_TERMCAP_us=${VT_GREEN_FG}
export LESS_TERMCAP_ue=${VT_RESET}
export LESS_TERMCAP_md=${VT_BLUE_FG}${VT_BOLD}
export LESS_TERMCAP_me=${VT_RESET}
# I do not like to clutter my home with history files
export LESSHISTFILE=/dev/null
# export LESS_TERMCAP_md=$'\e[1;34;40m'
# This prevents ^S from freezing the shell
# stty -ixon
ulimit -c unlimited
alias ..='cd ..'
alias -- -='cd -'
alias rm='rm -v -i'
alias mv='mv -v -i'
alias chmod='chmod -c'
alias cp='cp -v -i'
alias rd=rmdir
alias md='mkdir -pv'
alias ps='ps uxaf'
alias df='df -hT'
# alias df='df -hT --sync'
alias grep='grep -i -E --color=auto'
alias find='ionice -c3 find'
alias pd=pushd
alias val='valgrind --leak-check=full --show-reachable=yes --db-attach=yes '
alias s='screen -d -R default -U && clear'
alias p='feh --force-aliasing -d --full-screen --auto-zoom'
alias gp=gnuplot
function ext () {
find . -maxdepth 1 -type f | \grep \. | sed -e 's/^.*\.\([^/.]*\)$/\1/'
}
# function catscan () {
# convert signal-attachment-2020-06-01-192843.jpeg signal-attachment-2020-06-01-192829.jpeg -quality 25 -sigmoidal-contrast 10,45% -page a4 scan.pdf
# }
function trash-later () {
dir=${HOME}/misc/trash-later/remove-after-$(date --date='+3 months' +%Y-%b-%d)
mkdir -p "${dir}"
pushd "${dir}"
}
function nh () {
export HISTFILE=/dev/null
unalias cd
}
function select-tz () {
# Select a value for TZ
TMP=$(mktemp /tmp/select-tz.XXXXXX)
selector -o "${TMP}" <(grep -v ^# /usr/share/zoneinfo/zone.tab | awk '{print $3}' | sort -u)
cat "${TMP}"
\rm -f "${TMP}"
}
function ding () {
if [[ $1 ]] && which winshepherd.sh
then
play -q ~/local/sounds/deskbell.wav &
unset E_APP_WINDOW
winshepherd.sh message green "$1"
else
play -q ~/local/sounds/deskbell.wav
fi
}
alias impressive="impressive -s -D 1000 -t Crossfade -T 100"
if [[ -e "${HOME}/.dircolors" ]]
then
eval $(dircolors "${HOME}/.dircolors")
alias ls='ls -p --group-directories-first --color'
alias lt='ls -p --color -gohtr --time-style="+%Y %b %d %H:%M"'
alias ll='ls -p --color -goh --time-style="+%Y %b %d %H:%M"'
alias lll='ls -p --color -lth'
alias l='ls -p --color -I "*~" -I "*.o"'
alias less='less -R'
else
alias ls='ls -p --group-directories-first'
alias lt='ls -p -gohtr --time-style="+%Y %b %d %H:%M"'
alias ll='ls -p -goh --time-style="+%Y %b %d %H:%M"'
alias lll='ls -p -lth'
alias l='ls -p -I "*~" -I "*.o"'
fi
######################################################################
# Ignored extensions when completing
# export FIGNORE="CVS"
function latexdiff () {
wdiff -n \
-w $'\033[30;41m' -x $'\033[0m' \
-y $'\033[30;42m' -z $'\033[0m' \
"$@"
}
# Looks for the most recent .log and pdflatex + bibtex the
# corresponding tex file
function rl () {
# RECENT_LOG=$(ls -t $(find -maxdepth 1 -name "*.log" -type f) | head -1)
RECENT_LOG=$(ls -t *.log | head -1)
if [[ ${RECENT_LOG} ]]
then
FILEBASE="${RECENT_LOG/.log/}"
if [[ -f "${FILEBASE}.tex" ]]
then
pdflatex --shell-escape "${FILEBASE}"
bibtex "${FILEBASE}"
pdflatex --shell-escape "${FILEBASE}"
pdflatex --shell-escape "${FILEBASE}"
if [[ "$1" ]]
then
if [[ "$1" == "-v" ]] || [[ "$1" == "--view" ]]
then
# xpdf "${FILEBASE}.pdf"
zathura "${FILEBASE}.pdf"
elif [[ "$1" == "-p" ]] || [[ "$1" == "--print" ]]
then
lpr "${FILEBASE}.pdf"
else
echo "Usage: rl [-v|--view] [-p|--print]" >&2
echo "Unknown option $1" >&2
return 1
fi
fi
else
echo "Can not find a tex file corresponding to the most recent log (${RECENT_LOG/.log/})." >&2
return 1
fi
else
echo "Can not find a recent log." >&2
return 1
fi
}
######################################################################
# Functions
# http://www.reddit.com/r/linux/comments/2cgu5k/a_handy_little_script_for_interacting_with_your/
function clip () {
if [[ -t 0 ]] && [[ -z "$1" ]]
then
# output contents of clipboard
xclip -out -selection clipboard || exit 1
elif [[ "$1" ]]
then
# copy file contents to clipboard
xclip -in -selection clipboard < "$1" || exit 1
else
# copy stdin to clipboard
xclip -in -selection clipboard <&0 || exit 1
fi
}
# Find a file whose name contains a substring
function fn () {
name=$1
shift
find "$@" -name "*${name}*";
}
function bak () {
while [[ "$1" ]]
do
cp "$1" "$1".bak
shift
done
}
function scan () {
n=1
while [[ -f "${HOME}/scan-${n}.jpg" ]]
do
n=$((n+1))
done
while [[ "$1" ]]
do
if [[ "$1" == "color" ]]
then
OPTS+=" --mode Color"
elif [[ "$1" == "gray" ]]
then
OPTS+=" --mode Gray"
elif [[ "$1" == "a4crop" ]]
then
OPTS+=" -l 5 -t 0 -x 200 -y 300"
elif [[ "$1" == "help" ]] || [[ "$1" == "-h" ]] || [[ "$1" == "--help" ]]
then
echo "$0 [color|gray] [a4crop]" && return 0
else
echo "Unknown argument \`$1'"
fi
shift
done
echo "**"
echo "** Scanning to ${HOME}/scan-${n}.jpg"
echo "**"
SCANNER=$(scanimage -L | grep "Canon LiDE 60" | sed -e "s/^.*\`\(.*\)'.*$/\1/")
scanimage -d ${SCANNER} \
--format=pnm \
--mode=color \
--depth=8 \
-v \
--resolution=300 \
${OPTS} | \
convert -rotate 180 - "${HOME}/scan-${n}.jpg"
echo "** Done".
}
# A password generator
function genpw () {
if [[ "$1" == "-e" ]]
then
PW=$(tr -dc A-Z0-9 < /dev/urandom | head -c6)
shift
else
PW=$(tr -dc A-Za-z0-9 < /dev/urandom | head -c16)
fi
if [[ ! "$1" == "-s" ]]
then
echo "$(date) ${PW}" >> ${HOME}/private/genpw.log
fi
echo ${PW}
# tr -dc [:graph:] < /dev/urandom | head -c16
echo
}
function ua () {
[[ "$1" ]] || ( echo "Universal unarchive: ua [ ...]" >&2 && return 1)
while [[ "$1" ]]
do
case "$1" in
*.tgz|*.tar.gz|*.tbz|*.tar.bz2)
tar xvf "$1"
;;
*.rar)
unrar -kb x "$1"
;;
*.zip)
unzip "$1"
;;
*)
echo "Unknown file extension $1"
;;
esac
shift
done
}
# Create a dir and cd there
function mcd () {
mkdir -vp "$1"
cd "$1"
}
# Capture the screen in a dated png
function cap () {
if [[ $2 ]]
then
name=$2
else
name="capture-$(date +%Y%m%d-%H%M%S).png"
fi
if [[ "$1" ]]
then
echo "Waiting $1 s and saving to ${name}."
sleep "$1"
else
echo "Saving to ${name}."
fi
echo "Please click on the window to capture."
xwd | convert xwd:- ${name}
\ls -l ${name}
}
# Create and CD in a /tmp/tmp.XXXXXX directory. With the '-'
# arguments, do not create one and CD in the most recent instead
function cdt () {
if [[ "$1" ]]
then
if [[ "$1" == "-" ]]
then
cd $(\ls -td /tmp/tmp.?????? | head -1)
else
echo "USAGE: cdt [-]" >&2
return 1
fi
else
dir=$(mktemp -d /tmp/tmp.XXXXXX)
link=/tmp/tmp
if [[ -h ${link} ]]
then
\rm ${link}
fi
if [[ ! -a ${link} ]]
then
ln -s ${dir} ${link}
fi
cd ${dir}
fi
}
alias t='cd /tmp'
alias a='cd /tmp/at'
function trash () {
[[ "${TRASH_LATER_ROOT}" ]] || TRASH_LATER_ROOT="${HOME}/.trash"
if [[ "$1" == "--" ]]
then
shift
elif [[ "$1" == "-l" ]]
then
shift
echo "Trashin in 3 months"
TRASH_DIR="${TRASH_LATER_ROOT}/remove-after-$(date --date='+3 months' +%Y-%b-%d)"
mkdir -p "${TRASH_DIR}"
else
TRASH_DIR=$(date +/tmp/trash-${USER}-%Y-%b-%d-%Hh)
LINK=/tmp/trash
mkdir -p ${TRASH_DIR}
[[ -h ${LINK} ]] && \rm ${LINK}
[[ ! -f ${LINK} ]] && ln -s ${TRASH_DIR} ${LINK}
fi
mv "$@" "${TRASH_DIR}"
echo "Trashed $@"
}
function trashlatex () {
TRASH=$(date +/tmp/trash-latex-${USER}-%Y-%b-%d-%Hh)
LINK=/tmp/trash
mkdir -p ${TRASH}
[[ -h ${LINK} ]] && \rm ${LINK}
[[ ! -f ${LINK} ]] && ln -s ${TRASH} ${LINK}
mv -v \
*.log *.pdf *.aux *.nav *.pdfpc *.snm *.toc *.out \
*.bbl *.blg \
*.*.table *.*.gnuplot \
${TRASH}
}
######################################################################
## A version of pho which stores the image numbers in environment
## variables
function pho () {
TEMP=$(mktemp /tmp/pho.XXXXXXX)
$(which pho) "$@" | tee ${TEMP}
PHO_NOTE_1=$(grep ^"Note 1: " ${TEMP} | sed -e "s/^[^:]*: //")
PHO_NOTE_2=$(grep ^"Note 2: " ${TEMP} | sed -e "s/^[^:]*: //")
PHO_NOTE_3=$(grep ^"Note 3: " ${TEMP} | sed -e "s/^[^:]*: //")
PHO_NOTE_R90=$(grep ^"Rotate 90 \(CW\): " ${TEMP} | sed -e "s/^[^:]*: //")
PHO_NOTE_R180=$(grep ^"Rotate 180: " ${TEMP} | sed -e "s/^[^:]*: //")
PHO_NOTE_R270=$(grep ^"Rotate -90 \(CCW\): " ${TEMP} | sed -e "s/^[^:]*: //")
[[ "${PHO_NOTE_1}" ]] || unset PHO_NOTE_1
[[ "${PHO_NOTE_2}" ]] || unset PHO_NOTE_2
[[ "${PHO_NOTE_3}" ]] || unset PHO_NOTE_3
[[ "${PHO_NOTE_R90}" ]] || unset PHO_NOTE_R90
[[ "${PHO_NOTE_R180}" ]] || unset PHO_NOTE_R180
[[ "${PHO_NOTE_R270}" ]] || unset PHO_NOTE_R270
\rm ${TEMP}
}
######################################################################
## A version of date that shows the time at home if TZ is set
function dt () {
echo "Local - $(date)"
unset TZ
echo "Home - $(date)"
}
######################################################################
## ifup / ifdown with sudo
[ ${NETUP_HISTORY} ] || NETUP_HISTORY="${HOME}/.netup_history"
function netup () {
local upped_wifi
[[ "${WIFI_INTERFACE}" ]] || WIFI_INTERFACE=wlan0
if [[ "$1" == "--scan" ]]
then
if ifconfig -s | grep -v -q ${WIFI_INTERFACE}
then
sudo ifconfig ${WIFI_INTERFACE} up
upped_wifi=1
fi
sudo iwlist ${WIFI_INTERFACE} scan | \grep -E 'ESS|Quali|Encry' | sed -e 's/^[ \t]*//'
if [[ ${upped_wifi} ]]
then
sudo ifconfig ${WIFI_INTERFACE} down
unset upped_wifi
fi
return 0
fi
if \ifconfig -s | grep -q -v ^'(Iface|lo|docker[0-9]) '
then
echo "There is/are already interface(s) up." >&2
return 1
fi
if \ps h -C dhclient | grep -q .
then
echo "There is already a dhcp client running." >&2
return 1
fi
if \ps h -C wpa_supplicant | grep -q .
then
echo "There is already a wpa_supplicant running." >&2
return 1
fi
if [[ ! "$@" ]] && [[ -s ${NETUP_HISTORY} ]]
then
echo "netup " >&2
return 1
# # If we have no argument and there is a .netup_history, use it
# ARGS=$(cat ${NETUP_HISTORY})
else
# Otherwise uses the given arguments, and store them
ARGS="$@"
echo ${ARGS} > ${NETUP_HISTORY}
fi
if [[ "${PRIVATE_INTERFACE_DEFINITION}" ]]
then
ARGS="-i ${PRIVATE_INTERFACE_DEFINITION} ${ARGS}"
fi
echo "Executing ${VT_GREEN_FG}[sudo ifup ${ARGS}]${VT_RESET}"
sudo ifup ${ARGS}
# Ugly hack to remove the dsl modem dns server when we add
# explicitely a dns in the /etc/network/interfaces
REMOVE_LOCAL_DNS=/usr/local/bin/remove-local-dns.sh
# REMOVE_LOCAL_DNS=${HOME}/sources/scripts/remove-local-dns.sh
if [[ -x ${REMOVE_LOCAL_DNS} ]]
then
echo "Executing ${VT_GREEN_FG}[sudo ${REMOVE_LOCAL_DNS} 192.168]${VT_RESET}"
sudo ${REMOVE_LOCAL_DNS} 192.168
fi
}
function netdown () {
if [[ ! "$@" ]] && [[ -s ${NETUP_HISTORY} ]]
then
# If there are no arguments and there is a .netup_history, get the
# interface from it
ARGS=$(tail -1 ${NETUP_HISTORY} | sed -e "s/=.*$//")
else
# Otherwise, use the standard ifdown
ARGS="$@"
fi
[[ "${PRIVATE_INTERFACE_DEFINITION}" ]] && ARGS="-i ${PRIVATE_INTERFACE_DEFINITION} ${ARGS}"
echo "Executing sudo ${VT_GREEN_FG}[ifdown ${ARGS}]${VT_RESET}"
sudo ifdown ${ARGS}
# if [[ $(\ps -C dhclient | tail -n +2) ]]
# then
# echo "There is still a dhcp client running." >&2
# return 1
# fi
# if [[ $(\ps -C wpa_supplicant | tail -n +2) ]]
# then
# echo "There is still a wpa_supplicant running." >&2
# return 1
# fi
}
function checkgw () {
GW=$(route -n | grep ^0.0.0.0 | awk '{print $2}')
if [[ "${GW}" ]]
then
ping ${GW}
else
echo "Can not find a getaway." >&2
return 1
fi
}
######################################################################
# Show the most recent files, no scroll
function lr () {
TERM_SIZE=($(stty size))
INVIS="${VT_GREEN_FG}${VT_RESET}"
\ls -goth --time-style="+${VT_GREEN_FG}%Y %b %d %H:%M${VT_RESET}" "$@" | \
head -$((TERM_SIZE[0]-2)) | cut -b1-$((TERM_SIZE[1]+${#INVIS}))
}
######################################################################
reduce-pdf () {
# /screen selects low-resolution output
# /ebook selects medium-resolution output
# /printer selects "Print Optimized" setting.
# /prepress selects "Prepress Optimized" setting.
quality="printer"
while [[ "$1" ]]
do
if [[ "$1" == "--help" ]] || [[ "$1" == "-h" ]]
then
echo "$0 [|--quality ] ..."
return 0
elif [[ "$1" == "--quality" ]]
then
shift
quality="$1"
elif [[ -f "$1" ]]
then
result="$(basename "$1" .pdf)-${quality}.pdf"
echo -n "Generating ${result} with quality ${quality} ... "
gs -sDEVICE=pdfwrite \
-dCompatibilityLevel=1.4 \
-dPDFSETTINGS=/${quality} \
-dColorConversionStrategy=/LeaveColorUnchanged \
-dNOPAUSE -dQUIET -dBATCH \
-sOutputFile="${result}" "$1"
echo "done."
ls -hl "$1" "${result}"
else
echo "Cannot fine $1"
fi
shift
done
}
######################################################################
# You can change the xterm background color on the fly!
function setxtermbg () {
echo -n $'\e]11;'$1$'\007'
}
######################################################################
# Shuffle the lines from the stdin
function shuffle () {
SEED=$1
[[ $SEED ]] || SEED=0
awk 'BEGIN{srand('${SEED}')} { print rand()" "$0 }' | sort -g | sed -e "s/^[0-9\.e\-]* //"
}
######################################################################
# Stores the last entered command into a file
KEPT_COMMANDS=${HOME}/.kept_bash_commands
function keep () {
if [[ ${KEPT_COMMANDS} ]]
then
TOKEEP=$(mktemp /tmp/keep.XXXXXX)
if [[ "$@" ]]
then
echo "$@" > ${TOKEEP}
else
selector -b -i -d -l ${HISTSIZE} -o "${TOKEEP}" <(history)
fi
if [[ -s "${TOKEEP}" ]]
then
echo $(date)": "$(cat ${TOKEEP}) >> ${KEPT_COMMANDS}
cat "${TOKEEP}"
else
echo "No command stored!"
fi
\rm ${TOKEEP}
else
echo "You have to set \$KEPT_COMMANDS"
fi
}
######################################################################
# I sometime burn CDs and DVDs
function burn () {
[[ "${DEV_BURNER}" ]] || DEV_BURNER="/dev/sr0"
if [[ ! "$1" ]]
then
echo "burn " >&2
elif [[ -f "$1" ]]
then
if [[ $(file "$1" | \grep -E 'ISO 9660|UDF filesystem data') ]]
then
wodim -eject -v dev=${DEV_BURNER} "$1"
else
echo "Do not know what to do with $1" >&2
fi
elif [[ -d "$1" ]]
then
[[ "${TMP_ROOT}" ]] || TMP_ROOT=/tmp/
echo "Using ${TMP_ROOT} as temporary directory."
TMP=$(mktemp ${TMP_ROOT}/cdimage.XXXXXX) && \
genisoimage -input-charset iso8859-1 -r -o ${TMP} "$1" && \
wodim -eject -v dev=${DEV_BURNER} ${TMP}
rm -f ${TMP}
else
echo "Can not find $1" >&2
fi
}
######################################################################
# And watch DVDs too!
function dvd () {
echo
echo " ! @ Seek to the beginning of the previous/next chapter"
echo " j Cycle through the available subtitles"
echo " o Show/hide the timing"
echo " x z Subtitle delay"
echo " / * Volume"
echo
if [[ "$1" ]]
then
dvd_device="$1"
shift
else
dvd_device="/dev/dvd"
fi
title="1"
if [[ "$1" ]]
then
title=$1
shift
fi
# -vc ffmpeg12 -vf yadif
mplayer > /dev/null \
-stop-xscreensaver \
-quiet \
-alang en -slang en \
-softvol -softvol-max 1000 \
-dvd-device ${dvd_device} ${MPLAYER_OPTIONS} dvd://${title}
}
function ripdvd () {
if [[ -e "/dev/dvd" ]]
then
DVD_DEVICE="/dev/dvd"
elif [[ -e "/dev/dvd3" ]]
then
DVD_DEVICE="/dev/dvd3"
else
echo "Can not find the dvd device." >&2
return 1
fi
echo "Attempting to rip from ${DVD_DEVICE}."
mkdir -p ${HOME}/dvds
cd ${HOME}/dvds
time dvdbackup -i ${DVD_DEVICE} -v -M "$@" && eject
}
alias ripcd=abcde
######################################################################
# Create small images from images
function mksmall () {
if [[ "$1" == "--params" ]]
then
shift
PARAMS="$1"
shift
fi
[[ "${PARAMS}" ]] || PARAMS="-geometry 1280x1024"
# Auto-orient does not seem to work at all, hence the ugly hack
# with exif below
# PARAMS="-auto-orient -geometry 800x600"
echo "Using ${PARAMS}"
DEST_DIR=$1
[[ ${DEST_DIR} ]] || DEST_DIR=./small
mkdir -p ${DEST_DIR}
if [[ ! -d ${DEST_DIR} ]]
then
echo "Can not create ${DEST_DIR}" >&2
return
fi
NB_TOTAL=$(find -maxdepth 1 -type f | wc -l)
NB=0
for i in $(find -maxdepth 1 -type f)
do
if [[ $(file $i | grep image) ]]
then
if [[ -e ${DEST_DIR}/$i ]]
then
echo "The file ${DEST_DIR}/$i already exists."
else
if [[ $(file ${i/%.*/}.* | grep -E movie) ]]
then
CAPTION_PARAMS="-font FreeSans-Bold -pointsize 32 -fill green -annotate +10+32 Video"
else
CAPTION_PARAMS=""
fi
convert ${rotation_cmd} $i ${PARAMS} ${CAPTION_PARAMS} ${DEST_DIR}/$i
fi
\ls -lt ${DEST_DIR}/$i
fi
NB=$((NB+1))
echo "$((NB*100/NB_TOTAL))% (${NB}/${NB_TOTAL})"
done
}
######################################################################
# Move a file to the ~/sources/config directory and replace it where
# it was by a symbolic link
function mvtoconfig () {
CONFIGDIR=${HOME}/sources/config
if [[ -d ${CONFIGDIR} ]]
then
NEWNAME=${CONFIGDIR}/$(basename "$1" | sed -e "s/^\.//")
mv "$1" $NEWNAME
ln -s $NEWNAME $1
else
echo "Can not find ${CONFIGDIR}"
fi
}
######################################################################
# git prompt
if which > /dev/null git
then
parse_git_branch() {
git 2>/dev/null rev-parse --abbrev-ref HEAD | sed -e 's/^\(.*\)$/(\1) /'
}
export PS_GIT="${VT_GREEN_FG}\$(parse_git_branch)"
fi
######################################################################
# The complex prompt policy
export PS1
if [[ "${CONSOLE}" == "yes" ]]
then
PS1=""
else
# If the login is a standard one (as specified in
# IGNORED_PROMPT_LOGIN, which is set in the private bash file), do not
# show it. I have IGNORED_PROMPT_LOGIN="^fleuret$".
if [[ ! ${IGNORED_PROMPT_LOGIN} ]] || [[ ! ${USER} =~ ${IGNORED_PROMPT_LOGIN} ]]
then
IDENT="${USER}"
fi
# If the display is not the main one, make the assumption that the
# shell is not running on the localhost, and show the hostname
[[ "${DISPLAY}" != ":0.0" ]] && IDENT="${IDENT}@\h"
# If there is the login or the hostname, add a ":" to the prompt
[[ "${IDENT}" ]] && IDENT="${IDENT}:"
# IDENT="${PS_GIT}${VT_BLACK_FG}${IDENT}"
if [[ ${USER} == "root" ]]
then
# If we are root, show that in red
PS1="\[${VT_RED_BG}${VT_WHITE_FG}\]${IDENT}\w\[${VT_RESET}\] "
else
if [[ $(\grep QEMU /proc/cpuinfo) ]]
then
# If we are in a qemu virtual machine, in yellow
PS1="\[${VT_YELLOW_BG}${VT_BLACK_FG}\]${IDENT}\w\[${VT_RESET}\] "
else
# Otherwise in white
PS1="\[${VT_WHITE_BG}${VT_BLACK_FG}\]${IDENT}\w\[${VT_RESET}\] "
fi
fi
fi
#PS1="${PSCUE}${PS1}"
######################################################################
# This implements a local history. If we are in a directory containing
# a writable local history file, we add the last line of the global
# history to it.
LOCAL_HISTORY_FILE=".local_bash_history"
function keep_local_history () {
if [[ -w "${LOCAL_HISTORY_FILE}" ]]
then
history 1 | sed -e 's/^ *[0-9]* *//' >> ${LOCAL_HISTORY_FILE}
TMP=$(mktemp /tmp/lh.XXXXXX)
\chmod 600 ${TMP}
uniq < ${LOCAL_HISTORY_FILE} | tail -${HISTSIZE} > ${TMP}
# mv would replace a symbolic link, while cp keeps it
\cp ${TMP} ${LOCAL_HISTORY_FILE}
\rm ${TMP}
LOCAL_HISTORY_HINT="* "
else
LOCAL_HISTORY_HINT=""
fi
}
PS1="\[${VT_WHITE_BG}\]\${LOCAL_HISTORY_HINT}\[${VT_RESET}\]${PS1}"
######################################################################
# Show the history path if it is unusual
function histfile_cue () {
if [[ ! "${HISTFILE}" == "${HOME}/.bash_history" ]]
then
HISTORY_CUE="[${HISTFILE}]"
else
HISTORY_CUE=""
fi
}
PS1="\[${VT_YELLOW_BG}\]\${HISTORY_CUE}\[${VT_RESET}\]${PS1}"
######################################################################
# The dus command is available on my web site
#
# git clone http://fleuret.org/git/dus/
alias dus='dus -f -i'
######################################################################
# The finddup command is available on my web site
#
# git clone http://fleuret.org/git/finddup/
alias finddup='finddup -p'
######################################################################
# The selector command is available on my web site
#
# git clone http://fleuret.org/git/selector/
export SELECTOR_CD_HISTORY_SIZE=10000
source bash-selector.sh --hist --cd
######################################################################
# And we avoid to put in the history the use of the selector, which we
# do too often
HISTIGNORE="${HISTIGNORE}:selector-history"
######################################################################
function selector-printer () {
TMP=$(mktemp /tmp/selector-printer.XXXXXX)
selector -o ${TMP} <(lpstat -a | awk '{print $1}')
export PRINTER=$(cat ${TMP})
echo "PRINTER=${PRINTER}"
rm -f ${TMP}
lpq
}
######################################################################
# A ls with memory to notice what files have been added/removed from
# the current directory
function lsn () {
[[ "${LSN_STATE_FILE}" ]] || LSN_STATE_FILE=".lsn-state"
if [[ $1 == "--mem" ]] || [[ "$1" == "-m" ]]
then
\ls -pa | sort > "${LSN_STATE_FILE}"
echo "State updated." >&2
elif [[ $1 == "+" ]]
then
shift
TMP=$(mktemp /tmp/lsn.XXXXXX)
\ls -d "$@" > ${TMP}
cat "${LSN_STATE_FILE}" >> ${TMP}
sort ${TMP} | uniq -u > "${LSN_STATE_FILE}"
\rm ${TMP}
elif [[ "$1" ]]
then
cat >&2 < ...]
Where
--help|-h
prints this help
--mem|-m
stores the current state of the directory
+ [ ...]
switches the presence/absence of the indicated files in the
stored state
EOF
if [[ ! "$1" == "-h" ]] && [[ ! "$1" == "--help" ]]
then
echo >&2 "Unknown option \`\`$1''."
return 1
fi
else
if [[ -f "${LSN_STATE_FILE}" ]]
then
TMP=$(mktemp /tmp/lsn.XXXXXX)
\ls -pa | sort > ${TMP}
if diff > /dev/null ${TMP} "${LSN_STATE_FILE}"
then
echo "${VT_GREEN_FG}${VT_BOLD}No change (since $(date +"%b %d, %Y" -r "${LSN_STATE_FILE}"))${VT_RESET}"
else
\comm -1 -3 "${LSN_STATE_FILE}" ${TMP}
\comm -2 -3 "${LSN_STATE_FILE}" ${TMP} | while read line
do
echo "${VT_RED_FG}${VT_BOLD}${line}${VT_RESET} (missing)"
done
fi
\rm ${TMP}
else
echo "${VT_RED_FG}${VT_BOLD}No lsn state here.${VT_RESET}" >&2
return 1
fi
fi
}
######################################################################
function prompt_command () {
[[ "${CORE_CHECK_PWD}" == ${PWD} ]] || find . -maxdepth 1 -name "core__*" | awk '{print "'${VT_RED_FG}'"$0"'${VT_RESET}'"}'
CORE_CHECK_PWD=${PWD}
# if [[ $(umask) != 0022 ]]
# then
# echo "Umask changed to $(umask)"
# fi
# save the history after every command to avoid loosing some when
# multiple shells are open
history -a
# load the saved history
# history -n
# and the local histories system defined above
keep_local_history
# and the history cue
histfile_cue
}
PROMPT_COMMAND="prompt_command"
######################################################################
# Displaying the timezone if it is set
[[ ${TZ} ]] && echo "${VT_BLUE_FG}Time zone is ${TZ}.${VT_RESET}"
######################################################################
source /usr/share/bash-completion/bash_completion